/* 
 * $Id: MyGLSDDocumentModule.cpp,v 1.4 2005/10/17 10:18:36 ozawa Exp $
 *
 * GLSD external sample module program.
 *
 * Copyright 2005- ONGS Inc.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.4 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#include "xdtptypes.h"
#include "MyGLSDDocumentModule.h"
#include "MyGLSDImportModule.h"

#include "modules/GLSDDocumentModuleChecker.h"

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// interface

extern "C" u_int32_t getXDTPModuleVersion()
{
    return XDTP_MODULE_VERSION;
}

extern "C" XDTP::XDTPModule* buildXDTPModule()
{
	return (new MyGLSDDocumentModule());
}

extern "C" XDTP::XDTPChecker* buildXDTPChecker()
{
	return (new XDTP::GLSDDocumentModuleChecker());
}

extern "C" void freeXDTPModule(XDTP::XDTPModule* module)
{
	if (module) delete module;
}

extern "C" void freeXDTPChecker(XDTP::XDTPChecker* checker)
{
	if (checker) delete checker;
}

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// MyGLSDDocumentModule

MyGLSDDocumentModule::MyGLSDDocumentModule()
{
    m_ImportModules.push_back(new MyGLSDImportModule());
}

MyGLSDDocumentModule::~MyGLSDDocumentModule()
{
	// no operation
}
