/* 
 * $Id: XDTPTest.java,v 1.1 2005/10/06 11:57:44 ozawa Exp $
 *
 * This sample program is transform a glsd.xml to html.
 *
 * Copyright 2005- ONGS Inc.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

import jp.co.ongs.xdtp.transform.XDTPTransform;

class XDTPTest
{
	public static void main(String[] args)
    {
		XDTPTransform xdtp = new XDTPTransform();

		xdtp.setOutputType("html");
		xdtp.setVerboseMode(1);
		xdtp.setOutputEncoding("UTF-8");
		xdtp.addXSLFile("/usr/local/share/xdtp/toHTML/GLSD.xsl", true);
		xdtp.addXDTPModule("res:GLSDModule");          // local module
		xdtp.addXDTPModule("res:GLSDDocumentModule");  // local module

        if (!xdtp.initialize()) {
            System.err.println("XDTPTransform: Unable to initialize the XDTPTransform module.");
        }
        else {
            if (!xdtp.transform("glsd.xml", "glsd.html")) {
    			xdtp.showErrorMsg();
    		}
            xdtp.uninitialize();
        }
	}
}
