/* 
 * $Id: CSVAnalyzer.cpp,v 1.5 2005/10/19 14:05:44 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.5 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */
 
 #include "xdtp.h"
 #include "CSVAnalyzer.h"
 #include "Utilities.h"

using namespace XDTP;

CSVAnalyzer::CSVAnalyzer()
{
}

CSVAnalyzer::~CSVAnalyzer()
{
}

/**
 * CSV ǡϤList ǡ¤˳Ǽޤ
 * 
 * @param aLine
 *            ϸCSVǡ
 * @return List ǡ¤˳Ǽ CSV ǡ
 */
bool CSVAnalyzer::analyzeLine(const Glib::ustring& aLine, StringList& aList)
{
    // ڽФκǽΰ
    Glib::ustring::size_type startPoint = 0;

    // ڽФνΰ
    Glib::ustring::size_type nextPoint = 0;

    // ʸĹ
    Glib::ustring::size_type csvLenght = aLine.length();

    Glib::ustring token;

    aList.clear();

    nextPoint = nextCommaPoint(startPoint, aLine);
    while (nextPoint != Glib::ustring::npos &&
           nextPoint >= startPoint && nextPoint <= csvLenght)
    {
        token = aLine.substr(startPoint, nextPoint - startPoint);

        // ϤäƤ֥륯ơ
        if (1 < token.length() && '"' == token.at(0)) {
            token = token.substr(1, token.length() -2);
        }

        // פ줿֥륯ơ򸵤᤹
        token = Utilities::strReplaceAll(token, "\"\"", "\"");

        aList.push_back(token);
        startPoint = nextPoint + 1;
        nextPoint = nextCommaPoint(startPoint, aLine);
    }

    // ֥륯ơΰϤȴƤʤ false ֤
    if (nextPoint == Glib::ustring::npos) {
        aList.clear();
        return false;
    }

    return true;
}

/**
 * ꤵ줿ʹߤ, ˶ڤΥޤ֤ޤ
 * ˥ޤʤ, оݤʸĹԤޤ
 * ǡǤʤ(ȤХ֥륯ơΰϤ
 * λƤʤΤ˹ԤäƤ) -1 ֤ޤ
 * 
 * @param aStartPoint
 *            ϳϰ
 * @param aLine
 *            ϸCSVǡ
 * @return ˶ڤΥޤ֤, ǡĹǡ Ǥʤ -1 ֤ޤ
 */
Glib::ustring::size_type CSVAnalyzer::nextCommaPoint
    (Glib::ustring::size_type aStartPoint, const Glib::ustring& aLine)
{
    // Υޤޤǥ󥯥Ȥ֥ݥ
    Glib::ustring::size_type targetPoint = aStartPoint;

    // ʸĹ
    Glib::ustring::size_type csvLength = aLine.length();
    
    // оݤʸ
    Glib::ustring::value_type value;

    // ֥륯ơˤ뤫ʤɽޤCSV ǡ
    // , ǡ˥ޤ, Υǡ֥륯ơ
    // ǰϤळȤǶڤΥޤȶ̤ޤܿͤϤȽ
    // ޤ
    bool isQuoted = false;

    // ζڤꥫޤ뤫, ޤ
    for (; targetPoint < csvLength; targetPoint++) {
        value = aLine.at(targetPoint);
        if (',' == value && !isQuoted) {
            // ֥륯ơǤϤʤޤξ˼Υ
            // 褿ȽǤȴޤ
            break;
        }
        else if ('"' == value) {
            // CSV ǡ, ǡ˥֥륯ơ󤬤,
            // ΥǡĤΥ֥륯ơѴޤ
            // ν, Ϣ³ĤΥ֥륯ơˤϱƶ
            // Ϳ˰ϤߤΥ֥륯ơĴ٤뤳ȤǤ
            // ޤ
            isQuoted = !isQuoted;
        }
    }

    // ֥륯ơΰϤȴƤʤ -1 ֤ޤ
    if (isQuoted) {
        targetPoint = Glib::ustring::npos;
    }

    return targetPoint;
}
