/*
 * $Id: xmlsaver.cpp,v 1.1 2005/10/19 14:05:44 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#include "xdtp.h"
#include "xmlsaver.h"

#include "libxslt/xsltutils.h"

using namespace XDTP;

/**
 * 󥹥ȥ饯
 */
XMLSaver::XMLSaver()
{
}

/**
 * ǥȥ饯
 */
XMLSaver::~XMLSaver()
{
}

/**
 * XMLե¸ޤ
 * 
 * @param aPath ե
 * @param aDocument XMLɥ
 * @param aXSL XSLTԤäϽϷݻXSLɥȡ
 *             ԤäƤʤ NULL ꤹ롣
 * @param anEncoding ϥ󥳡
 * @return ¸ true ᤹
 */
bool XMLSaver::save(const Glib::ustring& aPath, const xmlDocPtr aDocument,
                    const xsltStylesheetPtr aXSL, const Glib::ustring& anEncoding)
{
    int status = -1;

    if (aXSL) {
        // fixme:
        // libxsltˤƽϥ󥳡ɤꤹؿ¸ߤʤ
        // Ū˲򤹤뤿ᡢѿľܽ񤭴롣
        // Ū԰¤ʥɤǤ뤿ᡢǤ᤯Ŭڤ
        // ؿ֤ by ozawa 2005/09/27
        if (aXSL->encoding) free(aXSL->encoding);
        aXSL->encoding = (xmlChar*)g_strdup(anEncoding.c_str());
        // ޤ - fixme
        
        status = xsltSaveResultToFilename(aPath.c_str(), aDocument, aXSL, 0);
    }
    else {
        status = xmlSaveFormatFileEnc(aPath.c_str(), aDocument, anEncoding.c_str(), 1);
    }

    return (-1 != status);
}

/**
 * XMLʸѴޤ
 * 
 * @param aDocument XMLɥ
 * @param anEncoding ϥ󥳡
 * @return ѴʸѴ˼Ԥ϶ʸ
 */
std::string XMLSaver::toString(const xmlDocPtr aDocument, const Glib::ustring& anEncoding)
{
    int size = 0;
    xmlChar* pMem = NULL;
    
    xmlDocDumpMemoryEnc(aDocument, &pMem, &size, anEncoding.c_str());
    
    std::string result = (const char*)pMem;

    xmlFree(pMem);

    return result;
}
